\ Decompiler

.( Loading Decompiler...)

defer (SEE)

INTERNAL

: .string ( ad1 ad2 n -- ad3 )
    type [char] " emit space count 2dup type
    [char] " emit space
    1+ + aligned ;

0 value immstr
: >imm ( xt -- )
    >name c@ 128 and if c" IMMEDIATE" else [ ' 0 >body ] literal then to immstr ;
: .imm ( -- )
    immstr count type ;

: .pfa ( ad -- )
    begin lcount dup ['] unnest <>
    while
      dup ['] lit = if drop lcount . else
      dup ['] _do = if drop ." DO " else
      dup ['] _?do = if drop ." ?DO " cell+ else
      dup ['] _loop = if drop ." LOOP " cell+ else
      dup ['] _+loop = if drop ." +LOOP " cell+ else
      dup ['] unloop = if drop dup @  ['] branch =
              if cell+  lcount 2 cells- @
                dup ['] _loop = swap ['] _+loop = or
                if ." LEAVE " else ." UNLOOP EXIT " then
              else ." UNLOOP "
              then else
      dup ['] _if = if drop ." IF " cell+ else
      dup ['] ?branch = if drop ." IF " cell+ else
      dup ['] branch = if drop ." EXIT " cell+ else
      dup ['] _else = if drop ." ELSE " cell+ else
      dup ['] _then = if drop ." THEN " else
      dup ['] _begin = if drop ." BEGIN " else
      dup ['] _while = if drop ." WHILE " cell+ else
      dup ['] _repeat = if drop ." REPEAT " cell+ else
      dup ['] _until = if drop ." UNTIL " cell+ else
      dup ['] _again = if drop ." AGAIN " cell+ else
      dup ['] (s") = if drop s" S" .string else
      dup ['] (c") = if drop s" C" .string else
      dup ['] (.") = if drop s" ." .string else
      dup ['] (abort") = if drop s" ABORT" .string else
      dup ['] init-locals = if drop ." INIT-LOCALS(" lcount h. ." ) " else
      dup @ dup 9 cells = swap 12 cells = or if ." TO " cell- body> .name else
      dup @ dup 10 cells = swap 13 cells = or if ." +TO " 2 cells- body> .name else
      .name
      then then then then then then then then then then then then
      then then then then then then then then then then then
    repeat ." ;" cr 2drop ;
: ?prim ( cfa [cfa] -- )
    drop .name ." is a primitive" cr ;
: ?var ( cfa [cfa] -- )
    dup 4 cells = if drop dup >body ?
      ." VARIABLE " .name .imm
      cr r>drop
    then ;
: ?con ( cfa [cfa] -- )
    dup 5 cells = if drop dup >body ?
      ." CONSTANT " .name .imm
      cr r>drop
    then ;
: ?val ( cfa [cfa] -- )
    dup 8 cells = if drop dup >body ?
      ." VALUE " .name .imm
      cr r>drop
    then ;
: ?def ( cfa [cfa] -- )
    dup 6 cells = if drop dup
      immstr >r
      >body @ dup>r (see)
      ." DEFER " dup .name
      r> to immstr  .imm
      ."   ' " r> .name ."  IS " .name cr
      r>drop
    then ;
: ?does
    dup 7 cells = if drop dup .name ." DOES> "
      cell+ @ .pfa .imm r>drop
    then ;
: ?col
    dup 2 cells = if drop ." : " dup .name
      >body .pfa .imm r>drop
    then ;

also oop
: ?mth
    over dup ['] cmth-exec =  swap ['] mth-exec = or
    if 2drop nip
      ." :m " dup .name
      >body .pfa  r>drop
    then ;

: ?obj
    dup 7 cells =  2 pick cell+ @ obj-xt = and
    if drop dup
      >body @ body> .name
      .name cr r>drop
    then ;

: ?cls
    dup 7 cells =  2 pick cell+ @ class-xt = and
    if drop ." CLASS " .name cr r>drop then ;

previous

: %see ( cfa -- )
    dup >imm
    dup @ ?cls ?obj ?mth ?col ?var ?con ?def ?does ?val ?prim ;
' %see is (see)

EXTERNAL

: SEE  cr ' (SEE) ;

MODULE
.( OK) cr
