\ Words
.( Loading words display utilities ... )

: LARGEST ( ad1 n -- ad2 res )
    0 0 2swap cells bounds
    ?do dup i @ u<
      if 2drop i dup @ then    
    cell +loop ;

comment:
INTERNAL

: dashes ( n -- )
    0 ?do [char] - emit loop ;

: %hor-line ( a n -- )
    cr dup if 2dup 78 dashes loop
    else 76 over - dup 3 / tuck - >r
      dashes space type space r> dashes
    then ;

variable vocsave

create words-pocket MAXSTRING allot

: .voc-once     ( -- )
    vocsave @ ?dup
    if      >name nfa-count %hor-line
      vocsave off
    then    ;

: match?        ( addr len -- f )
    2dup >r >r words-pocket count search nip nip
    pocket  c@
    if      r> r>    pocket count search nip nip and
    else    r> r> 2drop
    then       words-pocket c@ 0= or ;

0 value with-address?

: (words)       { voc \ words-pad$ w#threads -- }
                MAXSTRING LocalAlloc: words-pad$
                voc dup voc#threads to w#threads
                dup voc>vcfa @
                dup   doClass =         \ don't look through classes
                swap do|Class = or 0=   \ don't look through classes
        if      dup here 500 + w#threads cells move     \ copy vocabulary up
                voc>vcfa vocsave !
                begin   here 500 + w#threads largest dup
                while   dup l>name nfa-count 2dup "CLIP" words-pad$ place
                        words-pad$ ?uppercase count match?
                        if      .voc-once with-address?
                                if      2 pick link> dup here u>
                                        if      >bold ." +"
                                        else    space
                                        then    ." 0x" h.8 ."  " >norm
                                        type 30 #tab  space 30 ?cr
                                else    type 20 #tab  space 20 ?cr
                                then
                                1 +to words-cnt
                                start/stop
                                screendelay ms  \ slow down screen output
                        else    2drop
                        then
                        @ swap !
                repeat  2drop
        else    drop
        then    vocsave off ;

EXTERNAL

comment;
: WORDS
    0 context @
    here aligned 512 + over voc#threads 2dup 2>r cells move
    begin 2r@ largest ?dup
    while dup l>name nfa-count type space
      @ swap !
      1+
    repeat r>drop r>drop drop cr
    . ." words" cr ;

\ words
.( OK) cr
